using System;

namespace SampleGame
{
    /// <summary>
    /// ^XN(P)NX
    /// </summary>
    public class Task
    {
        //----
        // ^XN ID
        //----
        public enum ID
        {
	        // ftHg
	        DEFAULT	= -1,
            // vC[
            PLAYER,
            // GlM[Q[W
            ENERGY_GAGE,
        };

        //----
        // ^XN
        //----
        // ftHg
	    public static uint ATTRIBUTE_DEFAULT		    = 0x00000000;
    	// LN^[
	    public static uint ATTRIBUTE_CHARACTER			= 0x10000000;
        // fLN^[
        public static uint ATTRIBUTE_CHARACTER_MODEL    = 0x20000000;
        // XvCgLN^[
        public static uint ATTRIBUTE_CHARACTER_SPRITE   = 0x40000000;

        // ^XN ID(ID Q)
        public ID m_taskID;
	    // ^XN(ATTRIBUTE_* Q)
        public uint m_taskAttribute;
        // ^XNԍ
        public int m_taskNo = 0;
        // ^XNtO(true:, false:)
        public bool m_exist = true;
        // ^XNstO(true:s, false:~)
        public bool m_execute = true;

        /// <summary>RXgN^</summary>
        public Task()
        {
            // ^XN ID
            m_taskID = ID.DEFAULT;
            // ^XN
            m_taskAttribute = ATTRIBUTE_DEFAULT;
            // ^XNԍ
            m_taskNo = 0;
        }

        /// <summary>RXgN^</summary>
        /// <param name="taskID">^XN ID (Task.ID.*)</param>
        /// <param name="taskAttribute">^XN (Task.ATTRIBUTE_* ܂͔C)</param>
        public Task(ID taskID)
        {
            // ^XN ID
            m_taskID = taskID;
            // ^XN
            m_taskAttribute = ATTRIBUTE_DEFAULT;
            // ^XNԍ
            m_taskNo = 0;
        }

        /// <summary>RXgN^</summary>
        /// <param name="taskID">^XN ID (Task.ID.*)</param>
        /// <param name="taskAttribute">^XN (Task.ATTRIBUTE_* ܂͔C)</param>
        public Task(ID taskID, uint taskAttribute)
        {
            // ^XN ID
            m_taskID = taskID;
            // ^XN
            m_taskAttribute = taskAttribute | ATTRIBUTE_DEFAULT;
            // ^XNԍ
            m_taskNo = 0;
        }

        /// <summary>RXgN^</summary>
        /// <param name="taskID">^XN ID (Task.ID.*)</param>
        /// <param name="taskNo">^XNԍ(Cӂ̔ԍ)</param>
        public Task(ID taskID, int taskNo)
        {
            // ^XN ID
            m_taskID = taskID;
            // ^XN
            m_taskAttribute = ATTRIBUTE_DEFAULT;
            // ^XNԍ
            m_taskNo = taskNo;
        }

        /// <summary>RXgN^</summary>
        /// <param name="taskID">^XN ID (Task.ID.*)</param>
        /// <param name="taskAttribute">^XN (Task.ATTRIBUTE_* ܂͔C)</param>
        /// <param name="taskNo">^XNԍ(Cӂ̔ԍ)</param>
        public Task(ID taskID, uint taskAttribute, int taskNo)
        {
            // ^XN ID
            m_taskID = taskID;
            // ^XN
            m_taskAttribute = taskAttribute | ATTRIBUTE_DEFAULT;
            // ^XNԍ
            m_taskNo = taskNo;
        }

        /// <summary>mF܂</summary>
        /// <param name="attribute">(ATTRIBUTE_*)</param>
        /// <returns></returns>
        public bool IsAttribute(uint attribute)
        {
            if ((m_taskAttribute & attribute) == 0)
            {
                return false;
            }
            return true;
        }

        /// <summary>Cxg
        /// Xe[W^XNɓo^ƌĂяo܂
        /// </summary>
        public virtual void Initialize()
        {
            // hŔCӏ...
        }

        /// <summary>^XNs</summary>
        public virtual void Execute()
        {
            // hŔCӏ...
        }

        /// <summary>^XNŃCxg</summary>
        /// <param name="task">ł钼Õ^XN</param>
        public virtual void DestroyTask(Task task)
        {
            // hŔCӏ...
        }

        /// <summary>fobOs</summary>
        public virtual void DebugExecute()
        {
            // hŔCӏ...
        }
    }
}
