using System;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace SampleGame
{
    /// <summary>GlM[Q[W</summary>
    public class EnergyGageTask : SpriteCharacterTask
    {
        // GlM[Q[W摜
        Texture2D m_imageEnergy = null;
        Texture2D m_imageEnergyGage = null;

        // Q[Wő吔
        int m_gageMax = 1000;
        // GlM[
        int m_energy = 1000;

        /// <summary>RXgN^</summary>
        public EnergyGageTask()
            : base(ID.ENERGY_GAGE)
        {
            // wi𒼐ڕ`悵܂
            m_drawOverride = true;

            // 摜ǂݍ݂܂
            m_imageEnergy = SpriteTool.LoadSprite("Sprite/EnergyGageEnergy");
            m_imageEnergyGage = SpriteTool.LoadSprite("Sprite/EnergyGage");

            // s͍s܂
            m_execute = false;
        }

        /// <summary>`Cxg</summary>
        /// <remarks>
        /// ̊֐̓oϐ m_drawOverride  true ɂ
        /// Ăяo鎩O`CxgƂȂ܂
        /// </remarks>
        public override void Draw()
        {
            // `l
            int baseX = 16;
            int baseY = 8;

            // Q[Wg
            int boxCount = (m_gageMax / 100);

            // GlM[`悵܂
            if (m_energy > 0)
            {
                int energyX = (int)MathTool.TranslatePoint(
                    0, m_imageEnergyGage.Width * boxCount, 0, m_gageMax, m_energy);
                if (energyX == 0)
                {
                    energyX = 1;
                }
                Rectangle drawRect = new Rectangle(baseX, baseY, energyX - 1, m_imageEnergyGage.Height);
                drawRect = WindowNormalize(drawRect);
                SpriteTool.m_sprite.Draw(
                    m_imageEnergy, drawRect, new Rectangle(0, 0, 1, m_imageEnergyGage.Height), Color.White);

                drawRect = new Rectangle(baseX + energyX - 1, baseY, 1, m_imageEnergyGage.Height);
                drawRect = WindowNormalize(drawRect);
                SpriteTool.m_sprite.Draw(
                    m_imageEnergy, drawRect, new Rectangle(1, 0, 2, m_imageEnergyGage.Height), Color.White);
            }

            // Q[W`悵܂
            int x = baseX;
            for (int i = 0; i < m_gageMax; i += 100)
            {
                Rectangle drawRect = new Rectangle(x, baseY, m_imageEnergyGage.Width, m_imageEnergyGage.Height);
                drawRect = WindowNormalize(drawRect);
                SpriteTool.m_sprite.Draw(m_imageEnergyGage, drawRect, Color.White);
                x += m_imageEnergyGage.Width;
            }
        }
    }
}
